=== debian/changelog ===
kio (5.78.0-5) unstable; urgency=medium

  [ Norbert Preining ]
  * Cherry-pick upstream fix for kio caching/displaying websites etc
    instead of forwarding to the browser.

 -- Norbert Preining <norbert@preining.info>  Thu, 15 Jul 2021 10:20:01 +0900

kio (5.78.0-4) unstable; urgency=medium

  * Team upload.

  [ Aurélien COUDERC ]
  * Cherry-pick upstream fix:
    - Fix lockup when renaming a file from properties dialog

 -- Aurélien COUDERC <coucouf@debian.org>  Mon, 08 Feb 2021 10:12:11 +0100

kio (5.78.0-3) unstable; urgency=medium

  * Remove graphviz from build depends.
  * Cherry-pick upstream fix for crash in KIO's SkipDialog

 -- Norbert Preining <norbert@preining.info>  Wed, 03 Feb 2021 19:09:03 +0900

kio (5.78.0-2) unstable; urgency=medium

  * Release to unstable.

 -- Norbert Preining <norbert@preining.info>  Sun, 17 Jan 2021 12:02:22 +0900

kio (5.78.0-1) experimental; urgency=medium

  [ Norbert Preining ]
  * New upstream release (5.78.0).
  * Update build-deps and deps with the info from cmake.
  * Drop upstream included patch.
  * Update symbols.

 -- Norbert Preining <norbert@preining.info>  Wed, 13 Jan 2021 10:32:42 +0900

kio (5.77.0-3) unstable; urgency=medium

  * cherry-pick upstream fix add missing nullptr init
    (d/patches/upstream-9dc9e26b9196-add-missing-nullptr-init.patch)

 -- Norbert Preining <norbert@preining.info>  Mon, 28 Dec 2020 09:39:21 +0900

kio (5.77.0-2) unstable; urgency=medium

  * Release to unstable.

 -- Norbert Preining <norbert@preining.info>  Tue, 22 Dec 2020 10:33:35 +0900

kio (5.77.0-1) experimental; urgency=medium

  [ Norbert Preining ]
  * New upstream release (5.77.0).
  * Update build-deps and deps with the info from cmake.
  * Update symbols.
  * Update patches, disable Use-CXX_FLAGS-for-moc_predefs.h.patch.

 -- Norbert Preining <norbert@preining.info>  Fri, 18 Dec 2020 10:03:54 +0900

kio (5.74.1-1) unstable; urgency=medium

  * Team upload.
  * New upstream release:
    - fixes issue in kdeconnect (Closes: #975969)
  * Update renamed lintian tag names in lintian overrides.
  * Drop the transitional kio-dev package, no more needed now.
    (Closes: #939247)
  * Drop files of the unused 'acc' autopkgtest.

  [ Norbert Preining ]
  * Bump Standards-Version to 4.5.1 (No changes needed).
  * Add myself to Uploaders.
  * Update maintainer to Debian Qt/KDE Maintainers
    <debian-qt-kde@lists.debian.org>.

 -- Pino Toscano <pino@debian.org>  Wed, 16 Dec 2020 14:23:09 +0100

kio (5.74.0-2) unstable; urgency=medium

  * Team upload to unstable.

 -- Sandro Knauß <hefee@debian.org>  Mon, 19 Oct 2020 23:18:06 +0200

kio (5.74.0-1) experimental; urgency=medium

  * Team upload.

  [ Sandro Knauß ]
  * kded is an explicit runtime dependency of kio as it calls
    org.kde.kded5 via dbus.
  * New upstream release (5.74.0).
  * Update build-deps and deps with the info from cmake.
  * Add renamecategories file to libkf5kiocore5.install.
  * Update symbols from build for 5.74.0.
  * Update Homepage link to point to new invent.kde.org
  * Update field Source in debian/copyright to invent.kde.org move.
  * Update repository related entries to metadata file.
  * Update symbols from build for 5.74.0 no ABI bump needed (only
    private symbols got removed).
  * Add Bug-* entries to metadata file.

 -- Sandro Knauß <hefee@debian.org>  Sun, 27 Sep 2020 17:46:14 +0200
